# AUTOGENERATED! DO NOT EDIT! File to edit: ../../../nbs/abc/mock/01_base.ipynb.

# %% auto 0
__all__ = ['BaseMock']

# %% ../../../nbs/abc/mock/01_base.ipynb 3
from dataclasses import dataclass, field, KW_ONLY
import pandas as pd, numpy as np
from beartype.typing import Optional

# %% ../../../nbs/abc/mock/01_base.ipynb 4
from ...types import DataFrame
from .meta import MetaMock

# %% ../../../nbs/abc/mock/01_base.ipynb 7
@dataclass
class BaseMock(metaclass=MetaMock):
    _: KW_ONLY
    
    seed: Optional[int] = 3
    set_index: Optional[bool] = False

    def setup(self) -> DataFrame:
        pass

    def __post_init__(self):
        np.random.seed(self.seed)
        df = self.setup()
        self.df = df
        
    def make_col_names(self, n: int, prefix: Optional[str] = 'feature_', suffix: Optional[str] = ''):
        return [f'{prefix}{i}{suffix}' for i in range(n)]
    
    def head(self):
        return self.df.head()
    
    def tail(self):
        return self.df.tail()
