# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/00_types.ipynb.

# %% auto 0
__all__ = ['BoolLike', 'XYArray', 'DistanceArray', 'LabelArray', 'SequenceWithLength', 'SequencesWithLengths']

# %% ../nbs/00_types.ipynb 4
from iza.types import (
    Series, ndarray, Tensor, DataFrame, DataFrames, AnnData, AnnDatas,
    Numeric, Bool, Boolish, IndexLike, SeriesLike, IterLike, GroupKey,
    Number
)

from iza.types import (
    TrainValidSplit, TrainTestSplit, TrainValidTestSplit,
    DatasetSplitSpec, SplitDatasets,    
)

from iza.types import (
    SplitTuple2, SplitTuple3, SplitAsList,
    SplitDataset2Idxs, SplitDataset3Idxs, SplitDataFrames2, SplitDataFrames3
)

# %% ../nbs/00_types.ipynb 6
from beartype.typing import (Tuple, Union, TypeAlias)

import numpy as np
from nptyping import NDArray, Float, Shape, Number as AnyNumber, Bool as NPBool

import torch

# %% ../nbs/00_types.ipynb 8
BoolLike: TypeAlias = Union[bool, NPBool, np.bool_]

# %% ../nbs/00_types.ipynb 10
XYArray = NDArray[Shape["*, [x, y]"], Float]

DistanceArray = NDArray[Shape["*"], Float]

LabelArray = NDArray[Shape["*"], AnyNumber]

# %% ../nbs/00_types.ipynb 12
SequenceWithLength: TypeAlias = Tuple[torch.FloatTensor, int]

SequencesWithLengths: TypeAlias = Tuple[torch.FloatTensor, torch.IntTensor]
