# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/01_utils.ipynb.

# %% auto 0
__all__ = ['random_split_dataframe']

# %% ../nbs/01_utils.ipynb 3
import torch

# %% ../nbs/01_utils.ipynb 4
from .types import DataFrame, DatasetSplitSpec, SplitDatasets

# %% ../nbs/01_utils.ipynb 5
def random_split_dataframe(
    df: DataFrame,  
    splits: DatasetSplitSpec,
    as_dataframes: bool=False,
) -> SplitDatasets:
    
    subsets = torch.utils.data.random_split(df, splits)    
    
    indices = [subset.indices for subset in subsets]
    indices = tuple(indices)
    
    if as_dataframes:
        dfs: SplitDatasets = tuple([
            df.iloc[idxs].reset_index(drop=True)
            for idxs in indices
        ])
        return dfs
    
    return indices
